
local PlayButton
local StopButton
local RecordButton
local ClearButton
local AddButton
local RemoveButton
local HATProp
local HATFrame
local HATPanel
local OptionsPanel
local RenderPanel
local ButtonHoverEffect
local MaxObjsSlider
local FileName

local threadEnt = {}

function hanim.clLoadHAT()

MsgN("Henry's Animation Tools Client Initiated")

MsgN(GAMEMODE.Name)
if GAMEMODE.Name != "Sandbox" then return end

for k,v in pairs(hanim.PostLoadedSends) do
	v()
end

--TODO: Rename vgui variables.
--Overhaul the VGUI loading.
--DERMADESIGNER IS THE BOSS.

// Transfer all these functions from the server, so we can use it in the client.
hanim.Hook("servSetFrame")
hanim.Hook("servRecordFrame")
hanim.Hook("servClearFrame")
hanim.Hook("servPlay")
hanim.Hook("servStop")
hanim.Hook("servSetCurFrameLength")
hanim.Hook("servSetCurFrameTween")
hanim.Hook("servAddFrame")
hanim.Hook("servRemoveFrame")
hanim.Hook("servRender")
hanim.Hook("servSave")
hanim.Hook("servLoad")
hanim.Hook("servDeleteFile")

if hanim.GUILoaded then

	hanim.GUISettings()
	
end

hanim.GUILoaded = true
hanim.CurFrame = 0
HATFrame = vgui.Create('DFrame')
HATProp = vgui.Create( "DPropertySheet" )
HATPanel = vgui.Create('DPanel')
OptionsPanel = vgui.Create('DPanel')
RenderPanel = vgui.Create('DPanel')
MaxObjsSlider = vgui.Create('DNumSlider')
LagSlider = vgui.Create('DNumSlider')
KeyFramesPanel = vgui.Create('DPanel')
KeyFramesPanelList = vgui.Create('DPanel')
KeyFramesList = vgui.Create('DPanelList')
HorizontalScrollbar = vgui.Create('DHScrollBar')
HorizontalScrollbar:SetParent(KeyFramesPanel)
HorizontalScrollbar:SetSize(600, 15)
HorizontalScrollbar:SetPos(5, 35)
HorizontalScrollbar:SetScrollPanel(KeyFramesList)
PlayButton = vgui.Create('DButton')
StopButton = vgui.Create('DSysButton')
RecordButton = vgui.Create('DSysButton')
ClearButton = vgui.Create('DSysButton')
AddButton = vgui.Create('DButton')
RemoveButton = vgui.Create('DButton')

// My god this is so hacky.
ButtonHoverEffect = vgui.Create('DButton')
ButtonHoverEffect:SetText(" ")
ButtonHoverEffect.OnMouseReleased = function()
	ButtonHoverEffect:SetMouseInputEnabled(true)
	ButtonHoverEffect:KillFocus()
	ButtonHoverEffect:MouseCapture(false)
end
ButtonHoverEffect:OnMousePressed()
ButtonHoverEffect:SetVisible(false)


KeyFrames = {}

//Create the first keyframe.
//hanim.CreateKeyframe() Deprecated. Server now creates the first keyframe.

function hanim.GUISettings()

	HATFrame:SetPos(5,ScrH()-131)
	HATFrame:SetSize( 630, 126 )
	HATFrame:SetTitle(' ')
	HATFrame:SetDraggable(false)
	HATFrame:ShowCloseButton(false)
	HATFrame:MakePopup()
	HATFrame.Paint = function(self) end
	HATFrame:SetKeyboardInputEnabled( false )
	
	HATProp:SetParent(HATFrame)
	//HATProp:SetPos( 5, ScrH()-131 )
	HATProp:SetPos( 0, 0 )
	HATProp:SetSize( 630, 126 )
	
	HATPanel:SetSize(620, 95)
	//HATPanel:SetPos(5, ScrH()-100)
	HATProp:AddSheet( "Frames", HATPanel, "gui/silkicons/application_view_tile", false, false, "Edit all your frames here." )
	
	OptionsPanel:SetSize(620, 95)
	OptionsPanel.Paint = function(self)
		draw.RoundedBox(4, 0, 0, self:GetWide(), self:GetTall(), Color(52, 54, 59, 255))
	end
	HATProp:AddSheet( "Settings", OptionsPanel, "gui/silkicons/wrench", false, false, "Improve your framerate by adjusting these settings." )

	MaxObjsSlider:SetSize(160, 40)
	MaxObjsSlider:SetParent(OptionsPanel)
	MaxObjsSlider:SetPos(5,5)
	MaxObjsSlider:SetDecimals(0)
	MaxObjsSlider:SetConVar("hanim_maxobjs")
	MaxObjsSlider:SetToolTip("Maximum entities to loop through during a think. Set the value to the highest when rendering the movie.")
	MaxObjsSlider:SetText("Max Entities per Think")
	MaxObjsSlider:SetValue(0)
	MaxObjsSlider:SetMinMax(0, 30)

	LagSlider:SetSize(160, 40)
	LagSlider:SetParent(OptionsPanel)
	LagSlider:SetPos(5,50)
	LagSlider:SetDecimals(2)
	LagSlider:SetConVar("hanim_lag")
	LagSlider:SetToolTip("Delay of thinks (in milliseconds.) Balances out your framerate.")
	LagSlider:SetText("Delay for Next Think.")
	LagSlider:SetValue(0)
	LagSlider:SetMinMax(0, 2)

	RenderPanel:SetSize(620, 95)
	RenderPanel.Paint = function(self)
		draw.RoundedBox(4, 0, 0, self:GetWide(), self:GetTall(), Color(52, 54, 59, 255))
	end
	HATProp:AddSheet( "Render", RenderPanel, "gui/silkicons/bomb", false, false, "Saving your animation into demos." )

	FileName = vgui.Create('DTextEntry')
	FileName:SetParent(RenderPanel)
	FileName:SetSize(215, 20)
	FileName:SetPos(5, 50)
	FileName:SetText("untitled")
	//FileName.OnEnter = function() end

	DLabel4 = vgui.Create('DLabel')
	DLabel4:SetParent(RenderPanel)
	DLabel4:SetPos(5, 10)
	DLabel4:SetText('Start:')
	DLabel4:SizeToContents()

	DLabel5 = vgui.Create('DLabel')
	DLabel5:SetParent(RenderPanel)
	DLabel5:SetPos(155, 10)
	DLabel5:SetText('End:')
	DLabel5:SizeToContents()

	DNumberWang2 = vgui.Create('DNumberWang')
	DNumberWang2:SetParent(RenderPanel)
	DNumberWang2:SetPos(5, 25)
	DNumberWang2:SetSize(145, 20)
	DNumberWang2:SetDecimals(0)
	//DNumberWang2.OnMouseReleased = function() end
	//DNumberWang2.OnValueChanged = function() end
	DNumberWang2:SetValue(1)
	DNumberWang2:SetMinMax(1, #KeyFrames)

	DNumberWang3 = vgui.Create('DNumberWang')
	DNumberWang3:SetParent(RenderPanel)
	DNumberWang3:SetPos(155, 25)
	DNumberWang3:SetSize(145, 20)
	DNumberWang3:SetDecimals(0)
	//DNumberWang3.OnMouseReleased = function() end
	//DNumberWang3.OnValueChanged = function() end
	DNumberWang3:SetValue(1)
	DNumberWang3:SetMinMax(1, #KeyFrames)
	
	RenderButton = vgui.Create('DButton')
	RenderButton:SetParent(RenderPanel)
	RenderButton:SetSize(75, 20)
	RenderButton:SetPos(225, 50)
	RenderButton:SetText('Render')
	RenderButton.DoClick = function()
		local n1 = math.Clamp(DNumberWang2:GetValue(),1,#KeyFrames)
		local n2 = math.Clamp(DNumberWang3:GetValue(),1,#KeyFrames)
		if n2 > n1 then
		
			RunConsoleCommand("Record",FileName:GetValue())
			hanim.toRender = {n1,n2}
		end
	end

	KeyFramesPanel:SetParent(HATPanel)
	KeyFramesPanel:SetSize(610, 55)
	KeyFramesPanel:SetPos(5, 5)
	KeyFramesPanel.Paint = function(self)
		draw.RoundedBox(4, 0, 0, self:GetWide(), self:GetTall(), Color(52, 54, 59, 255))
	end
	
	KeyFramesPanelList:SetParent(KeyFramesPanel)
	KeyFramesPanelList:SetSize(600, 25)
	KeyFramesPanelList:SetPos(5, 5)
	KeyFramesPanelList:SetPaintBackground(false)
	
	KeyFramesList:SetParent(KeyFramesPanelList)
	//KeyFramesList:SetSize(600, 25)
	KeyFramesList:SetPos(0, 0)
	KeyFramesList:EnableHorizontal(true)
	KeyFramesList:SetDrawBackground(true)
	
	PlayButton:SetParent(HATPanel)
	PlayButton:SetToolTip("Play the animation, starting from the current frame.")
	PlayButton:SetSize(70, 25)
	PlayButton:SetPos(5, 65)
	PlayButton:SetText("Play")
	PlayButton.DoClick = function() hanim.Play() end
	
	StopButton:SetParent(HATPanel)
	StopButton:SetToolTip("Stop the animation.")
	StopButton:SetSize(40, 25)
	StopButton:SetPos(80, 65)
	StopButton:SetChar("g")
	StopButton.DoClick = function() hanim.Stop() end
	
	RecordButton:SetParent(HATPanel)
	RecordButton:SetToolTip("Snapshot the positions and angles of all selected objects into the current frame.")
	RecordButton:SetSize(40, 25)
	RecordButton:SetPos(125, 65)
	RecordButton:SetChar("h")
	RecordButton.DoClick = function() hanim.RecordFrame(hanim.CurFrame) end
	
	ClearButton:SetParent(HATPanel)
	ClearButton:SetToolTip("Clear the current frame")
	ClearButton:SetSize(40, 25)
	ClearButton:SetPos(170, 65)
	ClearButton:SetChar("r")
	ClearButton.DoClick = function() hanim.ClearFrame(hanim.CurFrame) end

	AddButton:SetParent(HATPanel)
	AddButton:SetToolTip("Add a frame after the current frame.")
	AddButton:SetSize(40, 25)
	AddButton:SetPos(215, 65)
	AddButton:SetText("+")
	AddButton.DoClick = function()
		hanim.AddFrame()
	end
	
	RemoveButton:SetParent(HATPanel)
	RemoveButton:SetToolTip("Remove the current frame.")
	RemoveButton:SetSize(40, 25)
	RemoveButton:SetPos(260, 65)
	RemoveButton:SetText("-")
	RemoveButton.DoClick = function()
		hanim.RemoveFrame()
	end
	
	FrameWang = vgui.Create('DNumberWang')
	FrameWang:SetParent(HATPanel)
	FrameWang:SetToolTip("Single Frame Length (in seconds).")
	FrameWang:SetPos(555, 65)
	FrameWang:SetDecimals(2)
	FrameWang:SetFraction(2)
	FrameWang.OMR = FrameWang.OnMouseReleased
	FrameWang.OnMouseReleased = function(self,mc)
		self:OMR(mc)
		hanim.SetCurFrameLength(self:GetValue())
	end
	--FrameWang.oldOnValueChanged = FrameWang.OnValueChanged
	--FrameWang.OnValueChanged = function(self,val) self:oldOnValueChanged(val) hanim.SetCurFrameLength(val) end
	FrameWang:SetValue(0.5)
	FrameWang:SetMinMax( 0, 50)
	FrameWang:SetWide(60)

	DMultiChoice1 = vgui.Create('DMultiChoice')
	DMultiChoice1:SetParent(HATPanel)
	DMultiChoice1:SetToolTip("The way an object moves to the next keyframe.")
	DMultiChoice1:SetPos(360, 65)
	DMultiChoice1:SetSize(190,20)
	DMultiChoice1:SetEditable(false)
	//DMultiChoice1.OnMousePressed = function() end
	DMultiChoice1.OnSelect = function(panel, index, value) hanim.servSetCurFrameTween(hanim.CurFrame,index) end
	DMultiChoice1:AddChoice('None')
	DMultiChoice1:AddChoice('Linear')
	DMultiChoice1:AddChoice('Start Fast, Slow Down')
	DMultiChoice1:AddChoice('Start Slow, Speed Up')
	DMultiChoice1:AddChoice('Start Slow, Speed Up, Slow Down')
	DMultiChoice1:AddChoice('Start Fast, Slow Down, Speed Up')
	DMultiChoice1:ChooseOptionID(2)

	HorizontalScrollbar:SetVisible(false)
	HATFrame:SetVisible(false)
	
end

//Probably will deprecate this function soon.
hanim.GUISettings()

function hanim.Think()
	if hanim.toRender then
		hanim.MenuClose()
		hanim.IsRendering = true
		hanim.servRender(hanim.toRender[1],hanim.toRender[2])
		hanim.toRender = nil
	end
end
hook.Add("Think","hanim_Think",hanim.Think)

function hanim.CreateKeyframe()
	k = #KeyFrames + 1
	local b = vgui.Create('DButton')
	b:SetSize(15, 25)
	b:SetText(" ")
	b:SetToolTip(" "..tostring(k).." ")
	b.n = k
	b.DoClick = function(self) hanim.SetFrame(self.n) end
	b.PaintOver = function(self)
		if math.fmod(self.n,5) == 0 then
			draw.RoundedBox(4, 1, 1, self:GetWide()-2, self:GetTall()-2, Color(100, 171, 221, 50))
		end
		if hanim.CurFrame == self.n then
			paintButtonHover(self:GetWide(),self:GetTall())
		end
	end
	KeyFrames[k] = b
	KeyFramesList:AddItem(KeyFrames[k])
	KeyFramesList:SetSize(k*15,25)
	HorizontalScrollbar:SetGripSize(k*15,600)
	DNumberWang2:SetMinMax(1, #KeyFrames)
	DNumberWang3:SetMinMax(1, #KeyFrames)
end

//What this does is that it paints a "hover" button effect.
//This is an extremely hacky method since I can't seem to find the source code for buttons.
function paintButtonHover(x,y)
	ButtonHoverEffect:SetSize(x,y)
	ButtonHoverEffect:Paint()
end

//////////////////////////////////////////////////////////////////////////////////////////////////////

function hanim.SetFrame(n)

	hanim.servSetFrame(n)

end

// The GUI sends the record command.
function hanim.RecordFrame(n)

	hanim.servRecordFrame(n,FrameWang:GetValue())

end

hanim.bonematrixes = {}

// This actually does a client-side record.
function hanim.clRecordFrame (frame)
	for k,v in pairs(ents.FindByClass("hanim_thread")) do
		hanim.bonematrixes[v:EntIndex()..frame] = {}
		if v.anim then
			for i=0,v.anim:GetBoneCount()-1 do
				local pos,ang = v.anim:GetBonePosition(i)
				local pos2 = nil
				local ang2 = nil
				if i == 0 then
					pos2 = v.anim:GetPos()
					ang2 = v.anim:GetAngles()
				end
				hanim.bonematrixes[v:EntIndex()..frame][i] = {pos,ang,pos2,ang2}
			end
		end
	end
end

function hanim.ClearFrame(n)

	hanim.servClearFrame(n)

end

function hanim.Play()

	hanim.servPlay()
	
end

function hanim.Stop(n)

	hanim.servStop()

end

function hanim.SetCurFrameLength(n)

	hanim.servSetCurFrameLength(hanim.CurFrame,n)

end

function hanim.SetCurFrameTween(n)
	hanim.servSetCurFrameTween(hanim.CurFrame,n)
end

function hanim.clSetFrame( n,wang,tween )
	hanim.CurFrame = n
	if wang then
		FrameWang:SetValue(wang)
	end
	if tonumber(tween) then
		if tween >= 1 and tween <= 6 then
			DMultiChoice1:ChooseOptionID(tween)
		else
			DMultiChoice1:ChooseOptionID(1)
		end
	end
end

function hanim.AddFrame()
	hanim.servAddFrame(hanim.CurFrame)
end

function hanim.RemoveFrame()
	hanim.servRemoveFrame(hanim.CurFrame)
end

function hanim.clAddFrame( n )
	if n and tonumber(n) then
		for i=1,n - #KeyFrames do
			hanim.CreateKeyframe()
		end
	else
		hanim.CreateKeyframe()
	end
end

local function ClampFloor (n,s)
	if n < s then
		n = s
	end
	return n
end

function hanim.clRemoveFrame()
	k = #KeyFrames
	if KeyFrames[k] then
		//if hanim.CurFrame == KeyFrames[k].n then
			hanim.SetFrame(ClampFloor(hanim.CurFrame - 1,1))
		//end
		KeyFrames[k]:Remove()
		KeyFramesList:RemoveItem(KeyFrames[k])
		KeyFramesList:SetSize((k-1)*15,25)
		HorizontalScrollbar:SetGripSize((k-1)*15,600)
		table.remove(KeyFrames,k)
	end
	DNumberWang2:SetMinMax(1, #KeyFrames)
	DNumberWang3:SetMinMax(1, #KeyFrames)
	if DNumberWang2:GetValue() > #KeyFrames then DNumberWang2:SetValue(#KeyFrames) end
	if DNumberWang3:GetValue() > #KeyFrames then DNumberWang3:SetValue(#KeyFrames) end
end

function hanim.MenuOpen(cmd,arg)
	if !hanim.IsRendering then
		RestoreCursorPosition()
		gui.EnableScreenClicker(true)
		HATFrame:SetVisible(true)
		HorizontalScrollbar:SetVisible(true)
		hanim.MenuVisible = true
		
		//HATProp:MakePopup()
		HATFrame:SetKeyboardInputEnabled( true )
		
		HATFrame:SetKeyboardInputEnabled(false)
		HATFrame:KillFocus()
		HATFrame.keyinput = false
	end
end
concommand.Add("+HATMenu",hanim.MenuOpen)

function hanim.MenuClose(cmd,arg)
	if !HATFrame.keyinput then
		RememberCursorPosition()
		gui.EnableScreenClicker(false)
		HorizontalScrollbar:SetVisible(false)
		HATFrame:SetVisible(false)
		hanim.MenuVisible = false
		
		HATFrame:SetKeyboardInputEnabled( false )
	end
end
concommand.Add("-HATMenu",hanim.MenuClose)

function hanim.RenderScreenspaceEffects()
	if hanim.MenuVisible then
		cam.Start3D(LocalPlayer():EyePos(),LocalPlayer():EyeAngles())
		for k,v in pairs(threadEnt) do
			local e = ents.GetByIndex(k)
			local r,g,b,a = e:GetColor()
			local mat = e:GetMaterial()
			render.SuppressEngineLighting( true )
			render.SetColorModulation(0,1,0)
			e:SetMaterial("models/wireframe")
			e:SetModelScale(Vector(1.05,1.05,1.05))
			e:DrawModel()
			e:SetMaterial(mat)
			e:SetModelScale(Vector(1,1,1))
			render.SuppressEngineLighting( false )
			render.SetColorModulation(1,1,1)
		end
		cam.End3D()
	end
end
hook.Add("RenderScreenspaceEffects","hanim_RenderScreenspaceEffects",hanim.RenderScreenspaceEffects)

function hanim.AddThreadEntity(e)
	threadEnt[e:EntIndex()] = true
end

function hanim.RemoveThreadEntity(e)
	threadEnt[e:EntIndex()] = nil
end

function hanim.clAddThreadEntity(e)
	threadEnt[e:EntIndex()] = true
end

function hanim.clRemoveThreadEntity(e)
	threadEnt[e:EntIndex()] = nil
end

function hanim.clStopRender()
	hanim.IsRendering = false
	RunConsoleCommand("stop")
end

function hanim.EntityRemoved(e)
	if threadEnt[e:EntIndex()] then
		threadEnt[e:EntIndex()] = nil
	end
end
hook.Add("EntityRemoved","HAT_EntityRemoved",hanim.EntityRemoved)

local function HATKeyGetFocus(p)
	if !ValidPanel(HATFrame) then return end
	if !p:HasParent(HATFrame) then return end
	if p == HATFrame then return end
	HATFrame:SetKeyboardInputEnabled(true)
	HATFrame:RequestFocus()
	HATFrame.keyinput = true
end

hook.Add( "OnTextEntryGetFocus", "HATKeyGetFocus", HATKeyGetFocus )

local function HATKeyLoseFocus(p)
	if !ValidPanel(HATFrame) then return end
	if !p:HasParent(HATFrame) then return end
	if p == HATFrame then return end
	//HATFrame:SetKeyboardInputEnabled(false)
	HATFrame:SetKeyboardInputEnabled(false)
	HATFrame:KillFocus()
	HATFrame.keyinput = false
end

hook.Add( "OnTextEntryLoseFocus", "HATKeyLoseFocus", HATKeyLoseFocus )

end