
local frames = {}
local framesOtherData = {}
framesOtherData[1] = {}
framesOtherData[1].framelength = 0.5
framesOtherData[1].tween = 2

local threadEnt = {}
local threadEnti = {}
local threadEntinv = {}

hook.Add( "PostGamemodeLoaded", "GamemodeLoadHATServer",
function ()

MsgN("Henry's Animation Tools Server Initiated")

MsgN(GAMEMODE.Name)
if GAMEMODE.Name != "Sandbox" then return end

--TODO: Save

hanim.CurFrame = 1
hanim.FrameBeforePlay = 1
hanim.FrameCount = 1
hanim.IsPlaying = false

hanim.OldFullAction = 0
hanim.OldBoneAction = 0
hanim.FullAction = 0
hanim.BoneAction = 0

hanim._lag = CreateConVar("hanim_lag",0.01, {FCVAR_REPLICATED, FCVAR_ARCHIVE})
hanim._maxobjs = CreateConVar("hanim_maxobjs",3, {FCVAR_REPLICATED, FCVAR_ARCHIVE})

hanim.isrendering = false
hanim.NextThink = 0

// For some reason STOOLS in singleplayer aren't client-sided.
if (SinglePlayer()) then
hanim.Hook("clAddThreadEntity")
hanim.Hook("clRemoveThreadEntity")
else
function hanim.clAddThreadEntity() end
function hanim.clRemoveThreadEntity() end
end

// Some client commands used to control gui.
hanim.Hook("clSetFrame")
hanim.Hook("clAddFrame")
hanim.Hook("clRemoveFrame")
hanim.Hook("clStopRender")
hanim.Hook("RePop")
hanim.Hook("clRecordFrame")
hanim.Hook("clLoadHAT")

hanim.Saves = file.Find("hat_saves/*.txt")

function hanim.servSetFrame( newframe )
 
	if !hanim.IsPlaying then
		hanim.CurFrame = newframe
		hanim.clSetFrame(newframe,hanim.GetFrameWang(newframe),hanim.GetFrameTween(newframe))
	end
	
end

function hanim.servRecordFrame ( frame,wang )

	if !hanim.IsPlaying then
	
		for k,v in pairs(threadEnt) do
			if type(v) == "Entity" or type(v) == "NPC" then
				v:Record(frame)
			end
		end
		
		if !framesOtherData[frame] then
			framesOtherData[frame] = {}
		end
		
		if wang then
			framesOtherData[frame].framelength = wang
		end
		
	end
	
	hanim.clRecordFrame ( frame )
	
end

function hanim.servClearFrame(frame)
	if !hanim.IsPlaying then
	
		for k,v in pairs(threadEnt) do
			if type(v) == "Entity" or type(v) == "NPC" then
				v:ClearFrame(frame)
			end
		end
		
		framesOtherData[frame] = {}
		framesOtherData[frame].framelength = 0.5 // Some default values.
		framesOtherData[frame].tween = 2
	end
end

function hanim.servAddFrame(frame)
	if !hanim.IsPlaying then
		hanim.clAddFrame()
		hanim.FrameCount = hanim.FrameCount + 1
		hanim.CurFrame = frame+1
		table.insert(framesOtherData,frame+1,{})
		for k,v in pairs(threadEnt) do
			if type(v) == "Entity" or type(v) == "NPC" then
				v:InsertFrame(frame+1)
			end
		end
		framesOtherData[frame+1].framelength = hanim.GetFrameWang(frame)
		framesOtherData[frame+1].tween = hanim.GetFrameTween(frame)
		if !framesOtherData[frame] then
			framesOtherData[frame+1].framelength = 0.5
			framesOtherData[frame+1].tween = 2
		end
		if frame <= 0 then
			hanim.clSetFrame(1,hanim.GetFrameWang(frame),hanim.GetFrameTween(frame))
		else
			hanim.clSetFrame(frame+1,hanim.GetFrameWang(frame),hanim.GetFrameTween(frame))
		end
	end
end

function hanim.servRemoveFrame( frame )
	if !hanim.IsPlaying and frame > 1 then
		hanim.clRemoveFrame()
		framesOtherData[frame] = {}
		table.remove(framesOtherData,frame)
		for k,v in pairs(threadEnt) do
			if type(v) == "Entity" or type(v) == "NPC" then
				v:RemoveFrame(frame)
			end
		end
		//framesOtherData[hanim.FrameCount] = nil
		hanim.FrameCount = math.Clamp(hanim.FrameCount - 1,1,2600)
		hanim.CurFrame = hanim.FrameCount
	end
end

function hanim.servSetCurFrameLength( frame,length )
	if !framesOtherData[frame] then
		framesOtherData[frame] = {}
	end
	framesOtherData[frame].framelength = length
end

function hanim.servSetCurFrameTween( frame,n )
	n = math.Clamp(n,0,6)
	if !framesOtherData[frame] then
		framesOtherData[frame] = {}
	end
	framesOtherData[frame].tween = n
end

function hanim.servPlay()
	if !hanim.IsPlaying then
		hanim.IsPlaying = true
		hanim.FrameBeforePlay = hanim.CurFrame
		hanim.CurTime = CurTime()
		for i=1,#threadEnti do
			local ent = ents.GetByIndex(threadEnti[i])
			ent:SetNoDraw(true)
		end
	end
end

function hanim.servStop()
	if !hanim.IsRendering then
		hanim.CurFrame = hanim.FrameBeforePlay
		hanim.clSetFrame(hanim.CurFrame,hanim.GetFrameWang(hanim.CurFrame),hanim.GetFrameTween(hanim.CurFrame))
		hanim.IsPlaying = false
		for i=1,#threadEnti do
			local ent = ents.GetByIndex(threadEnti[i])
			ent:SetNoDraw(false)
		end
	end
end

function hanim.servRender(n1,n2)
	if n1 and n2 then
		n1 = math.Clamp(n1,1,hanim.FrameCount)
		n2 = math.Clamp(n2,1,hanim.FrameCount)
		if n2 > n1 then
			hanim.IsRendering = true
			hanim.IsPlaying = true
			hanim.FrameBeforePlay = hanim.CurFrame
			hanim.CurFrame = n1-1
			hanim.StopAt = n2
		end
	end
end

-- Dividing by 0 will just return 0.
function hanim.div(a,b)
	if b == 0 or b == nil then
		return 0
	end
	return a/b
end

function hanim.Think()
	if hanim.IsPlaying then
		if CurTime() > hanim.CurTime+hanim.GetFrameWang(hanim.CurFrame,true) then
			hanim.CurFrame = hanim.CurFrame + 1
			hanim.CurTime = CurTime()
			if hanim.CurFrame > hanim.FrameCount then
				hanim.CurFrame = 1
			end
			hanim.clSetFrame(hanim.CurFrame,hanim.GetFrameWang(hanim.CurFrame),hanim.GetFrameTween(hanim.CurFrame))
		end
		if hanim.IsRendering then
			if hanim.CurFrame == hanim.StopAt then
				hanim.IsRendering = false
				hanim.servStop()
				hanim.clStopRender()
			end
		end
	end
	
	if CurTime() < hanim.NextThink+hanim._lag:GetFloat() and !hanim.IsRendering then return end
	local hfa = hanim.FullAction
	if hanim.IsRendering then
		hfa = 0
	end
	for i=1+hfa,#threadEnti do
		local ent = ents.GetByIndex(threadEnti[i])
		if ent then
			if ent['Wink'] then
				ent:Wink()
			end
		end
		if !hanim.IsRendering then
			hanim.FullAction = math.Clamp(hanim.FullAction + 1,0,#threadEnti)
			hanim.OldFullAction = hanim.OldFullAction + 1
			if (hanim.FullAction + hanim.BoneAction) >= hanim._maxobjs:GetFloat() then
				hanim.OldFullAction = 0
				break
			end
		end
	end
	hanim.OldFullAction = 0
	if hanim.FullAction == #threadEnti and hanim.BoneAction == 0 then
		hanim.FullAction = 0
	end
	hanim.NextThink = CurTime()
end
hook.Add("Think","HAT_Think",hanim.Think)

function hanim.EntityRemoved(e)
	if threadEnt[e] then
		threadEnt[e]:Remove()
		table.remove(threadEnti,threadEntinv[e])
		threadEnt[e] = nil
	end
end
hook.Add("EntityRemoved","HAT_EntityRemoved",hanim.EntityRemoved)

function hanim.AddThreadEntity(e)
	if !threadEnt[e] then
		local thread = ents.Create("hanim_thread")
		thread:SetPos(e:GetPos())
		thread:SetParent(e)
		thread:Spawn()
		thread:SetModel(e:GetModel())
		threadEnt[e] = thread
		threadEntinv[thread] = table.insert(threadEnti,thread:EntIndex())
		thread:SetAnimEnt(e)
		thread:SetNWEntity("ent",e)
	end
end

function hanim.RemoveThreadEntity(e)
	if threadEnt[e] then
		if threadEnt[e]:IsValid() then
			threadEnt[e]:Remove()
			table.remove(threadEnti,threadEntinv[e])
			threadEnt[e] = nil
		end
	end
	threadEnt[e] = nil
end

function hanim.GetThreadEntities()
	return threadEnt
end

function hanim.GetFrameWang(n,t)
	if n < 1 then
		return 0.5
	end
	if framesOtherData[n] then
		if !framesOtherData[n].framelength then
			return 0
		end
		return framesOtherData[n].framelength
	end
	if t then
		return 0
	end
	return nil
end

function hanim.GetFrameTween(n,t)
	if framesOtherData[n] then
		local fl = framesOtherData[n].tween
		if type(fl) != "number" then
			return 0
		end
		return fl
	end
	return 0
end

function hanim.NormalizeAngle(ang)
	return Angle(math.NormalizeAngle(ang.p),math.NormalizeAngle(ang.y),math.NormalizeAngle(ang.r))
end

local hpi = math.pi/2

// Credits: LassesIndex, thanks for the math and interpolation equations.
function hanim.ProcessDelta(p)
	local tw = framesOtherData[hanim.CurFrame].tween
	if p == 1 then
		return 1
	end
	if tw == 2 then
		return p
	elseif tw == 3 then
		return (math.sin(p*hpi))
	elseif tw == 4 then
		return (1 - math.sin(p*hpi+hpi)) // Had to recode, sine LassesIndex's equation didn't work.
	elseif tw == 5 then
		return (1/(1+math.exp(-10*p+5)))
	elseif tw == 6 then
		return ((math.log((1/p)-1)-5)/-10)
	end
	return 0
end

function hanim.InitialSpawn(pl)
	hanim.HookList = {pl}
	hanim.clLoadHAT()
	hanim.clAddFrame(hanim.FrameCount)
	hanim.clSetFrame(1)
	hanim.RePop(glon.encode(hanim.Saves))
end
hook.Add("PlayerInitialSpawn","hanimInitialSpawn", hanim.InitialSpawn)

function hanim.servSave(ent,filename)
	local thread = threadEnt[ent]
	if thread then
		thread:SaveAnim("hat_saves/"..filename..".txt")
		table.insert(hanim.Saves,filename..".txt")
		hanim.RePop(glon.encode(hanim.Saves))
	end
end

function hanim.servLoad(ent,filename)
	local thread = threadEnt[ent]
	if thread then
		if file.Exists("hat_saves/"..filename) then
			thread:LoadAnim("hat_saves/"..filename)
		end
	end
end

function hanim.servDeleteFile(filename)

	if file.Exists("hat_saves/"..filename) then
		file.Delete("hat_saves/"..filename)
	end
	for k,v in pairs(hanim.Saves) do
		if v == filename then
			table.remove(hanim.Saves,k)
			break
		end
	end
	hanim.RePop(glon.encode(hanim.Saves))
	
end

end)