
PANEL = {}
PANEL.scrollmaxwidth = 0
PANEL.scrollwidth = 100
PANEL.scrollpos = 0
PANEL.mouse = false
PANEL.n = 0
PANEL.m = 0

function PANEL:Init()

	self.LeftArrow = vgui.Create('DSysButton')
	self.RightArrow = vgui.Create('DSysButton')
	self.Grip = vgui.Create('DButton')
	self.Grip.OldPress = self.Grip.OnMousePressed
	self.Grip.OnMousePressed = function(grip)
		grip.OldPress(grip)
		local scroll = grip:GetParent()
		scroll:GripMousePressed()
	end
	self.Grip.OldReleased = self.Grip.OnMouseReleased
	self.Grip.OnMouseReleased = function(grip)
		grip.OldReleased(grip)
		local scroll = grip:GetParent()
		scroll:GripMouseReleased()
	end

end

function PANEL:PerformLayout()

	--TODO: Left Arrow
	self.LeftArrow:SetParent(self)
	self.LeftArrow:SetSize(15, self:GetTall())
	self.LeftArrow:SetPos(0, 0)
	self.LeftArrow:SetChar("3")
	self.LeftArrow.DoClick = function(l)
		if self.scrollpanel:GetWide() > self:GetWide() then
			local x,y = self.scrollpanel:GetPos()
			if self.scrollpanel then
				self.scrollpanel:SetPos(math.Clamp(x+15,self:GetWide()-self.scrollpanel:GetWide(),0),0)
			end
			x,y = self.scrollpanel:GetPos()
			self.scrollpos = -x/(self.n-self.m)*(self.scrollmaxwidth-math.ceil(math.Clamp(self.scrollwidth,15,self.scrollmaxwidth)))
			//self.scrollpos = math.ceil(self:GetMoveSizeInv(x))
			self.Grip:SetPos(15+self.scrollpos,0)
		end
	end
--[[	
function PANEL:GetMoveSize()
	local s = -(self.scrollpos)/(self.scrollmaxwidth-math.ceil(math.Clamp(self.scrollwidth,15,self.scrollmaxwidth)))*(self.n-self.m)
	return s
end

function PANEL:GetMoveSizeInv(s)
	local r = -s*(self.scrollmaxwidth-math.ceil(math.Clamp(self.scrollwidth,15,self.scrollmaxwidth)))*(self.n-self.m)
	return r
end]]
	--TODO: Right Arrow
	self.RightArrow:SetParent(self)
	self.RightArrow:SetSize(15, self:GetTall())
	self.RightArrow:SetPos(self:GetWide()-15, 0)
	self.RightArrow:SetChar("4")
	self.RightArrow.DoClick = function(r)
		if self.scrollpanel:GetWide() > self:GetWide() then
			local x,y = self.scrollpanel:GetPos()
			if self.scrollpanel then
				self.scrollpanel:SetPos(math.Clamp(x-15,self:GetWide()-self.scrollpanel:GetWide(),0),0)
			end
			x,y = self.scrollpanel:GetPos()
			self.scrollpos = -x/(self.n-self.m)*(self.scrollmaxwidth-math.ceil(math.Clamp(self.scrollwidth,15,self.scrollmaxwidth)))
			//self.scrollpos = math.ceil(self:GetMoveSizeInv(x))
			self.Grip:SetPos(15+self.scrollpos,0)
		end
	end
	
	self.scrollmaxwidth = self:GetWide()-30
	
	self.Grip:SetParent(self)
	self.Grip:SetSize(math.Clamp(self.scrollwidth,15,self.scrollmaxwidth),15)
	self.Grip:SetPos(15+self.scrollpos,0)
	self.Grip:SetText(" ")
	self.Grip.DoClick = function() end
	
	
end

function PANEL:GripMousePressed()
	self.oldscrollpos = self.scrollpos
	self.mx = gui.MouseX()
	self.mouse = true
end

function PANEL:GripMouseReleased()
	self.mx = 0
	self.mouse = false
end

function PANEL:SetGripSize(n,m)
	self.scrollmaxwidth = self:GetWide()-30
	local mdn = math.Clamp(m/n,0,1)
	self.scrollwidth = mdn*(self:GetWide()-30)
	self.Grip:SetSize(math.ceil(math.Clamp(self.scrollwidth,15,self.scrollmaxwidth)),15)
	self.n = n
	self.m = m
	self.scrollpos = math.Clamp(self.scrollpos,0,(self.scrollmaxwidth-self.scrollwidth))
	self.Grip:SetPos(15+self.scrollpos,0)
	
	if self.scrollpanel then
		self.scrollpanel:SetPos(self:GetMoveSize(),0)
	end
	
	//KeyFramesList:SetPos(HorizontalScrollbar:GetMoveSize(),0)
end

function PANEL:GetMoveSize()
	local s = -(self.scrollpos)/(self.scrollmaxwidth-math.ceil(math.Clamp(self.scrollwidth,15,self.scrollmaxwidth)))*(self.n-self.m)
	return s
end

function PANEL:SetScrollPanel(p)
	self.scrollpanel = p
end

function PANEL:SetVisible(b)

	self.LeftArrow:SetVisible(b)
	self.RightArrow:SetVisible(b)
	self.Grip:SetVisible(b)
	
end

function PANEL:Paint()
	if self.mouse then
		self.scrollpos = math.Clamp(self.oldscrollpos + gui.MouseX() - self.mx,0,(self.scrollmaxwidth-math.ceil(math.Clamp(self.scrollwidth,15,self.scrollmaxwidth))))
		self.Grip:SetPos(15+self.scrollpos,0)
		if self.scrollpanel then
			self.scrollpanel:SetPos(self:GetMoveSize(),0)
		end
	end

	draw.RoundedBox(4, 0, 0, self:GetWide(), self:GetTall(), Color(68, 68, 68, 255))
	
	derma.SkinHook( "Paint", "HScrollBar", self )
	derma.SkinHook( "PaintOver", "HScrollBar", self )

end

derma.DefineControl( "DHScrollBar", "Horizontal scroll bar", PANEL, "Panel" )