TOOL.Category = "HAT"
TOOL.Name = "Outputer"
TOOL.Command = nil -- What is this for?
TOOL.ConfigName = ""
TOOL.Tab			= "Wire"

if CLIENT then
	language.Add("Tool_hanim_wire_name", "HAT Output Spawner (Wire)")
	language.Add("Tool_hanim_wire_desc", "Spawn a HAT Outputer")
	language.Add("Tool_hanim_wire_0", "Primary: Create Outputer.")
	language.Add("sboxlimit_hanim_wire", "You've hit your Pod Controller limit!")
	language.Add("Undone_Wire HAT", "Undone Wire HAT Outputer")
end

if SERVER then
	CreateConVar('sbox_maxhanim_wire', 1)
	ModelPlug_Register("podctrlr")
end

TOOL.ClientConVar[ "model" ] = "models/jaanus/wiretool/wiretool_siren.mdl"

cleanup.Register("hanim_wire")

function TOOL:LeftClick(trace)
	if not trace.HitPos then return false end
	if trace.Entity:IsPlayer() then return false end
	if CLIENT then return true end

	local ply = self:GetOwner()

	if not self:GetSWEP():CheckLimit("hanim_wire") then return false end

	local Ang = trace.HitNormal:Angle()
	Ang.pitch = Ang.pitch + 90

	local wire_outputer = MakeWireOutputer(ply, trace.HitPos, Ang, self:GetModel())

	wire_outputer:SetPos(trace.HitPos - trace.HitNormal * wire_outputer:OBBMins().z)
	
	local const = WireLib.Weld(wire_outputer, trace.Entity, trace.PhysicsBone, true)

	undo.Create("HAT Wire")
		undo.AddEntity(wire_outputer)
		undo.AddEntity(const)
		undo.SetPlayer(ply)
	undo.Finish()

	ply:AddCleanup("hanim_wire", wire_outputer)

	return true
end

function TOOL:RightClick(trace)

end

function TOOL:Reload(trace)
	self:SetStage(0)
	self.PodCont = nil
end

if SERVER then

	function MakeWireOutputer(pl, Pos, Ang, model)
		if not pl:CheckLimit("hanim_wire") then return false end
		
		local wire_outputer = ents.Create("hanim_wire")
		if not wire_outputer:IsValid() then return false end
		
		wire_outputer:SetAngles(Ang)
		wire_outputer:SetPos(Pos)
		wire_outputer:SetModel(Model(model or "models/jaanus/wiretool/wiretool_siren.mdl"))
		wire_outputer:Spawn()
		wire_outputer:SetPlayer(pl)
		wire_outputer.pl = pl
		
		pl:AddCount("hanim_wire", wire_outputer)
		
		return wire_outputer
	end
	
	duplicator.RegisterEntityClass("hanim_wire", MakeWireOutputer, "Pos", "Ang", "Model", "Keys")
end

function TOOL:UpdateGhostWirePod(ent, player)
	if  not ent or not ent:IsValid() then return end

	local tr = utilx.GetPlayerTrace(player, player:GetCursorAimVector())
	local trace = util.TraceLine(tr)

	if not trace.Hit or trace.Entity:IsPlayer() or trace.Entity:GetClass() == "hanim_wire" then
		ent:SetNoDraw(true)
		return
	end

	local Ang = trace.HitNormal:Angle()
	Ang.pitch = Ang.pitch + 90

	ent:SetPos(trace.HitPos - trace.HitNormal * ent:OBBMins().z)
	ent:SetAngles(Ang)

	ent:SetNoDraw(false)
end

function TOOL:Think()
	local model = self:GetModel()

	if (!self.GhostEntity || !self.GhostEntity:IsValid() || self.GhostEntity:GetModel() != model ) then
		self:MakeGhostEntity( Model(model), Vector(0,0,0), Angle(0,0,0) )
	end

	self:UpdateGhostWirePod(self.GhostEntity, self:GetOwner())
end

function TOOL:GetModel()
	local model = "models/jaanus/wiretool/wiretool_siren.mdl"
	local modelcheck = self:GetClientInfo( "model" )

	if (util.IsValidModel(modelcheck) and util.IsValidProp(modelcheck)) then
		model = modelcheck
	end
	
	return model
end

function TOOL.BuildCPanel(panel)
	panel:AddControl("Header", { Text = "#Tool_wire_pod_name", Description = "#Tool_wire_pod_desc" })
	ModelPlug_AddToCPanel(panel, "podctrlr", "wire_pod", nil, nil, nil, 1)
end
